# frozen_string_literal: true

=begin ========================================================================
= Copyright (c) AgiliCity d.o.o. 2024. All Rights Reserved.                   =
=                                                                             =
= By using this software, you agree to respect Terms and Conditions, End User =
= License Agreement and other related documents that can be found on our      =
= website (https://modelur.com/legal/).                                       =
=                                                                             =
= Make sure this file is not encoded by Ruby Encoder:                         =
= RubyEncoder:DO_NOT_ENCODE                                                   =
=end ==========================================================================
require_relative '../../src/constants/par_constants'
require_relative '../gis/gis_constants'

module Modelur
  OSM_SOURCE_UUID = 'dcb8ff0b-a4b2-42f7-97a3-9191d6977420'
  OSM_BUILDING = 'building'
  OSM_PAR_MAPPING = 'parameters_mapping'
  OSM_TYPE_TO_USE_MAPPING = 'type_to_use_mapping'
  OSM_NAME = 'name'
  OSM_LEVELS = 'levels'
  OSM_HEIGHT = 'height'
  OSM_BUILT = 'built'
  OSM_TYPE = 'type'
  OSM_PROPERTIES_MAPPING = {
    PAR_NAME => OSM_NAME,
    PAR_NUM_OF_STOREYS => OSM_LEVELS,
    PAR_BUILDING_HEIGHT => OSM_HEIGHT,
    PAR_CONSTRUCTION_DATE => OSM_BUILT,
    PAR_LAND_USE => OSM_TYPE
  }.freeze
  OSM_PREFERENCES = {
    Gis::PREF_GENERATE_MISSING_USES => false,
    Gis::PREF_GIS_LOCK_IMPORTED_OBJECTS => true
  }.freeze
  OSM_TYPE_TO_USE_MAP = {
    'administration' => 'Public',
    'agriculture' => 'Farm',
    'agriculture:barn' => 'Farm',
    'agriculture:farm' => 'Farm',
    'agriculture:greenhouse' => 'Farm',
    'agriculture:stable' => 'Farm',
    'bridge' => 'Transport',
    'commerce' => 'Commercial',
    'commerce:office' => 'Office',
    'commerce:retail' => 'Commercial',
    'culture' => 'Culture',
    'culture:recreation' => 'Sports',
    'culture:religion' => 'Religious',
    'culture:sports' => 'Sports',
    'education' => 'Education',
    'education:college' => 'Education',
    'education:kindergarten' => 'Education',
    'education:school' => 'Education',
    'education:university' => 'Education',
    'industry' => 'Industry',
    'industry:other' => 'Industry',
    'industry:chimney' => 'Industry',
    'industry:silo' => 'Industry',
    'industry:storage' => 'Industry',
    'industry:supply' => 'Industry',
    'industry:tank' => 'Industry',
    'industry:waste_management' => 'Industry',
    'military' => 'Military',
    'other' => 'Other',
    'other:construction' => 'Other',
    'other:mast' => 'Other',
    'other:roof' => 'Other',
    'other:shed' => 'Other',
    'public' => 'Public',
    'public:healthcare' => 'Healthcare',
    'residence' => 'Residential',
    'residence:other' => 'Residential',
    'transport' => 'Transport',
    'transport:aviation' => 'Transport',
    'transport:bridge' => 'Transport',
    'transport:station' => 'Transport'
  }.freeze
end
