module Modelur

  module RgLoader320
    # The version of the ruby loader
    RUBY_LOADER_VERSION = '3.2.0'

    module_function

    # @return [String] the path to `loader.rb` of this package
    def loader_file
      path = __dir__.dup
      path.force_encoding('UTF-8') if path.respond_to?(:force_encoding)
      File.join(path, 'loader.rb')
    end

    # Unload RgLoader if the version of currently loaded loader is not the same as this one. To prevent errors due to
    # un-compatible RgLoader versions that some other plugin might install and load.
    def reload!
      # Make sure we have proper loaders loaded, as some plugins (eg. Skalp)
      # overload it...Since 2.5.1 this info is stored in RGLoader itself
      # Removing loader from $LOADED_FEATURES will enable loading RgLoader again if it was overloaded by other plugin in
      # the meantime.
      if RGLoader.get_const('loader_version') != RUBY_LOADER_VERSION
        loader_file = self.loader_file
        $LOADED_FEATURES.reject! { |path| path.dup.force_encoding('UTF-8').start_with?(loader_file) }
        require loader_file
      end
    end
  end
end
