# frozen_string_literal: true

require_relative '../constants/platform_constants'

module Modelur
  extension = if OPERATING_SYSTEM == OS_WIN
                'so'
              else
                'bundle'
              end
  clipper_file = "clipper_#{RUBY_VERSION_NUMBER}.#{extension}"
  require_relative(File.join('clipper', clipper_file))

  # Default Clipper object to perform polygon (clipping) operations
  CLIPPER = Clipper2.new
  CLIPPER_OFFSET = ClipperOffset.new
  # Prepare Clipper with high multiplier for GIS as we are potentially checking
  #   polygons defined in decimal degrees (EPSG:4326 coordinates)...
  CLIPPER_HIRES = Clipper2.new
  CLIPPER_HIRES.multiplier = 10_000_000
end
