# encoding: UTF-8

module Modelur
  module Earcut
    # Node to hold point data and its previous and next points.
    # @param i [Fixnum] vertex index in coordinates array.
    # @param x [Float] vertex coordinate.
    # @param y [Float] vertex coordinate.
    class Node
      attr_accessor :i, :x, :y, :z, :prev, :next, :prev_z, :next_z, :steiner

      def initialize(i, x, y)
        # vertices index in coordinates array
        @i = i
        # vertex coordinates
        @x = x
        @y = y
        # previous and next vertices nodes in a polygon ring
        @prev = nil
        @next = nil
        # z-order curve value
        @z = nil
        # previous and next nodes in z-order
        @prev_z = nil
        @next_z = nil
        # indicates whether this is a steiner point
        @steiner = false
      end
    end
  end
end
